/*:
# **Kapitel 2.4**
## **Aufgabe 7 Fußballmanager**
Teil eines Fußballmanager-Simulationsspiels ist es, die Spielaufstellung festzulegen. Ein Kleinfeld-Team besteht hier aus einem Torwart und vier Feldspielern. In der Klasse MANAGER wurden bereits alle neun Spieler des Kaders (Feldspieler und Ersatzspieler) angelegt.\
a\
Vereinbare ein Feld feldspieler, lege es im Konstruktor an und erstelle dann eine Methode *StartfünfFestlegen()*, in der du dem Feld fünf der bereits vorhandenen Spieler hinzufügst.\
b\
Die aufgestellten Spieler sollen angezeigt werden: Erstelle eine Methode *TeamAnzeigen()*, in der für jeden Feldspieler die Methode *Anzeigen()* aufgerufen wird. Rufe die Methode am Ende der Methode aus a) auf.\
Im Folgenden wird eine Hilfsmethode benötigt, die eine Spielernummer erhält und die Referenz auf das zugehörige Spielerobjekt zurückgibt.\
c\
Erstelle die Methode *SpielerGeben(rückennummer)* gemäß dem abgebildeten Struktogramm.\
d\
Damit in Spielpartien ein Platzverweis ausgesprochen werden kann, wird eine Methode *RoteKarteGeben(rückennummer)* benötigt. Darin soll zunächst der zur angegebenen Rückennummer gehörige Spieler ermittelt werden. Anschließend muss dieser aus dem Feld und auch aus der Anzeige entfernt werden. Erstelle die Methode.\
e\
Für Schnelle: Teste und erkläre, warum ein Fehler entsteht, wenn du bei *RoteKarteGeben* die Rückennummer eines Spielers angibst, der gerade gar nicht spielt. Behebe den Fehler, indem du in die Methode eine Sicherheitsüberprüfung einbaust. Falls der Spieler nicht aufgestellt ist, soll eine passende Warnmeldung ausgegeben werden.
*/


/**
Fußballspieler

- author: Johannes Neumeyer
- version: 1.0
*/
class Spieler: Figur
{
    private let name: String
    private let rückennummer: Int
    private let xStart: Int
    private let yStart: Int
    private let farbe: Int
    private let trikotnummer: Text
    private let anzeigename: Text

    /**
	Der Konstruktor legt die verwalteten Daten fest und erzeugt die Darstellung
	- parameters:
		- spielername: Name des Spielers
    	- spielernummer: die (Rücken-)Nummer des Spielers
    	- startposX: x-Koordinate der Startposition
    	- startposY: xy-Koordinate der Startposition
    	- farbe: die Hautfarbe
    */
    init(spielername: String, spielernummer: Int, startposX: Int, startposY: Int, farbe: Int)
    {
        name = spielername
        rückennummer = spielernummer
        xStart = startposX
        yStart = startposY
        self.farbe = farbe

        trikotnummer = Text()
        trikotnummer.TextSetzen(text: String(spielernummer))
        trikotnummer.FarbeSetzen(farbe: "schwarz")
        trikotnummer.GanzNachVornBringen()

        anzeigename = Text()
        anzeigename.TextSetzen(text: spielername)
        anzeigename.FarbeSetzen(farbe: "schwarz")
        super.init()

        FigurFestlegen()
    }

	/**
	Legt das Aussehen der Figur fest
    */
    private func FigurFestlegen()
    {
        var hf: String
        if farbe == 1
        {
            hf = "orange"
        }
        else if farbe == 2
        {
            hf = "braun"
        }
        else
        {
            hf = "magenta"
        }

        // Kopf
        FigurteilFestlegenEllipse(x: -8, y: -50, breite: 16, höhe: 16, farbe: hf)
        // Mund
        FigurteilFestlegenRechteck(x: -2, y: -38, breite: 4, höhe: 1, farbe: "rot")
        // Hals
        FigurteilFestlegenRechteck(x: -4, y: -36, breite: 8, höhe: 6, farbe: hf)
        FigurteilFestlegenDreieck(x1: -5, y1: -30, x2: 0, y2: -25, x3: 5, y3: -30, farbe: hf)
        // Brust
        FigurteilFestlegenDreieck(x1: -14, y1: -22, x2: 0, y2: -25, x3: 14, y3: -22, farbe: "grün")
        // Bauch
        FigurteilFestlegenRechteck(x: -14, y: -22, breite: 28, höhe: 28, farbe: "grün")
        // Unterbauch
        FigurteilFestlegenDreieck(x1: -12, y1: 6, x2: 0, y2: 14, x3: 12, y3: 6, farbe: "schwarz")

        // Auge links
        FigurteilFestlegenEllipse(x: -3, y: -44, breite: 2, höhe: 2, farbe: "blau")
        // Schulter links
        FigurteilFestlegenDreieck(x1: -20, y1: -26, x2: -14, y2: -22, x3: -5, y3: -30, farbe: "grün")
        FigurteilFestlegenDreieck(x1: 0, y1: -25, x2: -14, y2: -22, x3: -5, y3: -30, farbe: "grün")
        // Oberarm links
        FigurteilFestlegenDreieck(x1: -20, y1: -26, x2: -24, y2: -10, x3: -18, y3: -10, farbe: "grün")
        FigurteilFestlegenDreieck(x1: -20, y1: -26, x2: -18, y2: -10, x3: -14, y3: -22, farbe: "grün")
        // Unterarm links
        FigurteilFestlegenRechteck(x: -24, y: -10, breite: 6, höhe: 20, farbe: "grün")
        // Hand links
        FigurteilFestlegenEllipse(x: -25, y: 8, breite: 8, höhe: 8, farbe: hf)
        // Hose links
        FigurteilFestlegenDreieck(x1: -12, y1: 6, x2: -15, y2: 22, x3: 0, y3: 14, farbe: "schwarz")
        FigurteilFestlegenDreieck(x1: -2, y1: 22, x2: -15, y2: 22, x3: 0, y3: 14, farbe: "schwarz")
        // Oberschenkel links
        FigurteilFestlegenRechteck(x: -12, y: 22, breite: 9, höhe: 9, farbe: hf)
        // Unterschenkel links
        FigurteilFestlegenDreieck(x1: -12, y1: 31, x2: -10, y2: 46, x3: -6, y3: 46, farbe: hf)
        FigurteilFestlegenDreieck(x1: -12, y1: 31, x2: -6, y2: 46, x3: -3, y3: 31, farbe: hf)
        // Schuh links
        FigurteilFestlegenEllipse(x: -17, y: 46, breite: 13, höhe: 4, farbe: "weiß")

        // Auge rechts
        FigurteilFestlegenEllipse(x: 1, y: -44, breite: 2, höhe: 2, farbe: "blau")
        // Schulter rechts
        FigurteilFestlegenDreieck(x1: 20, y1: -26, x2: 14, y2: -22, x3: 5, y3: -30, farbe: "grün")
        FigurteilFestlegenDreieck(x1: 0, y1: -25, x2: 14, y2: -22, x3: 5, y3: -30, farbe: "grün")
        // Oberarm rechts
        FigurteilFestlegenDreieck(x1: 20, y1: -26, x2: 24, y2: -10, x3: 18, y3: -10, farbe: "grün")
        FigurteilFestlegenDreieck(x1: 20, y1: -26, x2: 18, y2: -10, x3: 14, y3: -22, farbe: "grün")
        // Unterarm rechts
        FigurteilFestlegenRechteck(x: 18, y: -10, breite: 6, höhe: 20, farbe: "grün")
        // Hand rechts
        FigurteilFestlegenEllipse(x: 17, y: 8, breite: 8, höhe: 8, farbe: hf)
        // Hose rechts
        FigurteilFestlegenDreieck(x1: 12, y1: 6, x2: 15, y2: 22, x3: 0, y3: 14, farbe: "schwarz")
        FigurteilFestlegenDreieck(x1: 2, y1: 22, x2: 15, y2: 22, x3: 0, y3: 14, farbe: "schwarz")
        // Oberschenkel rechts
        FigurteilFestlegenRechteck(x: 3, y: 22, breite: 9, höhe: 9, farbe: hf)
        // Unterschenkel rechts
        FigurteilFestlegenDreieck(x1: 12, y1: 31, x2: 10, y2: 46, x3: 6, y3: 46, farbe: hf)
        FigurteilFestlegenDreieck(x1: 12, y1: 31, x2: 6, y2: 46, x3: 3, y3: 31, farbe: hf)
        // Schuh rechts
        FigurteilFestlegenEllipse(x: 4, y: 46, breite: 13, höhe: 4, farbe: "weiß")

        // Spielernummer & -name
        TextePositionieren()

        GrößeSetzen(größe: 100)
        PositionSetzen(x: -100, y: 0)
    }

	/**
	Positioniert die Spielerfigur
	
	Auch die Texte werden passend positioniert
	- parameters:
		- x: x-Koordinate der Position
		- y: y-Koordinate der Position
    */
    override func PositionSetzen(x: Int, y: Int)
    {
        super.PositionSetzen(x: x, y: y)
        TextePositionieren()
    }

	/**
	Entfernt die Figur aus der Anzeige
	
	Auch die Texte werden entfernt
    */
    override func Entfernen()
    {
        super.Entfernen()
        trikotnummer.Entfernen()
        anzeigename.Entfernen()
    }

	/**
	Setzt den Spieler auf seine Starposition und damit dei Figur in den sichtbaren Bereich
    */
    func Anzeigen()
    {
        PositionSetzen(x: xStart, y: yStart)
    }

	/**
	Positioniert die Texte passend zu Spielerposition
    */
    private func TextePositionieren()
    {
        trikotnummer.PositionSetzen(x: XPositionGeben() - 8, y: YPositionGeben() - 5)
        anzeigename.PositionSetzen(x: XPositionGeben() - 25, y: YPositionGeben() + 65)
    }

	/**
	Gibt die Rückennummer zurück
	- returns: Rückennummer
    */
    func RückennummerGeben() -> Int
    {
        return rückennummer
    }
}

/**
Management eines Fußballteams auf einem Kleinfeld

- author: Johannes Neumeyer
- version: 1.0
*/
class Manager
{
    private var brichzin: Spieler
    private var zirbnich: Spieler
    private var jetzinger: Spieler
    private var grenzjeti: Spieler
    private var janus: Spieler
    private var reinold: Spieler
    private var drnoeli: Spieler
    private var wiedemann: Spieler
    private var damenwein: Spieler

    /**
    Legt die vorhandenen Spieler an
    */
    init()
    {
        brichzin = Spieler(spielername: "Brichzin", spielernummer: 7, startposX: 50, startposY: 50, farbe: 1)
        zirbnich = Spieler(spielername: "Zirb Nich", spielernummer: 2, startposX: 150, startposY: 50, farbe: 2)
        jetzinger = Spieler(spielername: "Jetzinger",spielernummer: 3, startposX: 250, startposY: 50, farbe: 2)
        grenzjeti = Spieler(spielername: "Grenz-Jeti", spielernummer: 1, startposX: 50, startposY: 175, farbe: 2)
        janus = Spieler(spielername: "Janus", spielernummer: 5, startposX: 150, startposY: 175, farbe: 1)
        reinold = Spieler(spielername: "Reinold", spielernummer: 6, startposX: 250, startposY: 175, farbe: 3)
        drnoeli = Spieler(spielername: "Dr Noeli", spielernummer: 8, startposX: 50, startposY: 300, farbe: 1)
        wiedemann = Spieler(spielername: "Wiedemann", spielernummer: 9, startposX: 150, startposY: 300, farbe: 2)
        damenwein = Spieler(spielername: "Damenwein", spielernummer: 4, startposX: 250, startposY: 300, farbe: 3)
    }
}
