/*:
# **Kapitel 2.4**
## **Aufgabe 8 Smart-Home Prototyp 2**
Die einzelnen Messgeräte und Komponenten der Smart-Home-App sollen nun besser verwaltet werden.\
*/

/**
Ein graues Rechteck für die Wände des Hauses

- author: Johannes Neumeyer
- version: 1.0
*/
class Hausmauer: Rechteck
{

    /**
    Konstruktor für Objekte der Klasse Hausmauer
    */
    override init()
    {
        super.init()
        FarbeSetzen(farbe: "grau")
    }
    
    /**
    Konstruktor für Objekte der Klasse Hausmauer  mit angegebener Position
	- parameters:
		- x: x-Koordinate
		- y: y-Koordinate
    */
    convenience init(x: Int, y:Int)
    {
        self.init()
        PositionSetzen(x: x, y: y)
    }
}

/**
Darstellung eines Fensters

- author: Johannes Neumeyer
- version: 1.0
*/
class FensterSymbol
{
    private var links: Rechteck
    private var rechts: Rechteck
    private var oben: Rechteck
    private var unten: Rechteck
    private var kreuzSenkrecht: Rechteck
    private var kreuzWaagrecht: Rechteck

    /**
    Erzeugt das Fenstersymbol
	- parameters:
		- x: x-Koordinate
		- y: y-Koordinate
    */
    init(x: Int, y: Int)
    {
        let höhe = 100
        let breite = höhe

        links = Rechteck()
        links.GrößeSetzen(breite: 2, höhe: höhe)
        links.PositionSetzen(x: x, y: y)
        links.FarbeSetzen(farbe: "braun")

        oben = Rechteck()
        oben.GrößeSetzen(breite: breite, höhe: 2)
        oben.PositionSetzen(x: x, y: y)
        oben.FarbeSetzen(farbe: "braun")

        unten = Rechteck()
        unten.GrößeSetzen(breite: breite, höhe: 2)
        unten.PositionSetzen(x: x, y: y + höhe - 2)
        unten.FarbeSetzen(farbe: "braun")

        rechts = Rechteck()
        rechts.GrößeSetzen(breite: 2, höhe: höhe)
        rechts.PositionSetzen(x: x + breite - 2, y: y)
        rechts.FarbeSetzen(farbe: "braun")

        kreuzSenkrecht = Rechteck()
        kreuzSenkrecht.GrößeSetzen(breite: 2, höhe: höhe)
        kreuzSenkrecht.PositionSetzen(x: x + breite / 2, y: y)
        kreuzSenkrecht.FarbeSetzen(farbe: "braun")

        kreuzWaagrecht = Rechteck()
        kreuzWaagrecht.GrößeSetzen(breite: breite, höhe: 2)
        kreuzWaagrecht.PositionSetzen(x: x, y: y + höhe / 2)
        kreuzWaagrecht.FarbeSetzen(farbe: "braun")
    }
}

/**
Der Hintergrund des Hauses

- author: Johannes Neumeyer
- version: 1.0
*/
class HintergrundSymbol
{
    /**
    Legt die Wände, das Dach und die Beschriftung an.
    */
    init()
    {
        let dachlinks = Dreieck()
        dachlinks.FarbeSetzen(farbe: "rot")
        dachlinks.GrößeSetzen(breite: 550, höhe: 100)
        dachlinks.PositionSetzen(x: 400, y: 0)
        let unten = Hausmauer(x: 150, y: 500)
        unten.GrößeSetzen(breite: 500, höhe: 5)
        let mitteWaagrecht = Hausmauer(x: 150, y: 300)
        mitteWaagrecht.GrößeSetzen(breite: 500, höhe: 5)
        let oben = Hausmauer(x: 150, y: 100)
        oben.GrößeSetzen(breite: 500, höhe: 5)
        let links = Hausmauer(x: 150, y: 100)
        links.GrößeSetzen(breite: 5, höhe: 400)
        let rechts = Hausmauer(x: 645, y: 100)
        rechts.GrößeSetzen(breite: 5, höhe: 400)
        let mitteSenkrecht = Hausmauer(x: 395, y: 100)
        mitteSenkrecht.GrößeSetzen(breite: 5, höhe: 400)
        FensterSymbol(x: 250, y: 125)
        FensterSymbol(x: 250, y: 325)
        FensterSymbol(x: 500, y: 125)
        FensterSymbol(x: 500, y: 325)

        let wohnzimmer1 = Text()
        wohnzimmer1.TextSetzen(text: "Wohnzimmer1")
        wohnzimmer1.FarbeSetzen(farbe: "grau")
        wohnzimmer1.TextGrößeSetzen(größe: 15)
        wohnzimmer1.PositionSetzen(x: 160, y: 120)

        let wohnzimmer2 = Text()
        wohnzimmer2.TextSetzen(text: "Wohnzimmer2")
        wohnzimmer2.FarbeSetzen(farbe: "grau")
        wohnzimmer2.TextGrößeSetzen(größe: 15)
        wohnzimmer2.PositionSetzen(x: 405, y: 120)

        let küche = Text()
        küche.TextSetzen(text: "Küche")
        küche.FarbeSetzen(farbe: "grau")
        küche.TextGrößeSetzen(größe: 15)
        küche.PositionSetzen(x: 160, y: 320)

        let esszimmer = Text()
        esszimmer.TextSetzen(text: "Esszimmer")
        esszimmer.FarbeSetzen(farbe: "grau")
        esszimmer.TextGrößeSetzen(größe: 15)
        esszimmer.PositionSetzen(x: 405, y: 320)
    }
}

/**
Darstellung eines Heizkörpers

- author: Johannes Neumeyer
- version: 1.0
*/
class HeizkörperSymbol
{
    private var innenkreise: [Kreis]
    private var innenrechtecke: [Rechteck]

	/**
	Baut das Symbol auf
	- parameters:
		- x: x-Koordinate
		- y: y-Koordinate
    */
    init(x: Int, y: Int)
    {
        innenkreise = []
        innenrechtecke = []
        
        for index in 0 ..< 8
        {
            HeizkörperSegmentAnPos(x: x + index * 10, y: y)
        }
    }
    
    /**
	Meldet den neuen Zustand an das Symbol
	- parameters:
		- an: der Heizkörper ist eingeschaltet
    */
    func ÄnderungMelden(an: Bool)
    {
        if an
        {
            for k in innenkreise
            {
                k.FarbeSetzen(farbe: "rot")
            }
            
            for r in innenrechtecke
            {
                r.FarbeSetzen(farbe: "rot")
            }

        }
        else
        {
            for k in innenkreise
            {
                k.FarbeSetzen(farbe: "weiß")
            }
            
            for r in innenrechtecke
            {
                r.FarbeSetzen(farbe: "weiß")
            }
        }
    }

	/**
	Fügt dem Heizkörper ein neues Segment hinzu
	- parameters:
		- x: x-Koordinate
		- y: y-Koordinate
    */
    private func HeizkörperSegmentAnPos(x: Int, y: Int)
    {
        // Segment außen
        let oben = Kreis()
        oben.RadiusSetzen(radius: 10)
        oben.PositionSetzen(x: x + 10, y: y + 10)
        oben.FarbeSetzen(farbe: "schwarz")

        let mitte = Rechteck()
        mitte.GrößeSetzen(breite: 21, höhe: 40)
        mitte.PositionSetzen(x: x, y: y + 10)
        mitte.FarbeSetzen(farbe: "schwarz")

        let unten  = Kreis()
        unten.RadiusSetzen(radius: 10)
        unten.PositionSetzen(x: x + 10, y: y + 50)
        unten.FarbeSetzen(farbe: "schwarz")

        // Segment innen
        let obenInnen = Kreis()
        obenInnen.RadiusSetzen(radius: 8)
        obenInnen.PositionSetzen(x: x + 10, y: y + 10)
        obenInnen.FarbeSetzen(farbe: "weiß")
        innenkreise.append(obenInnen)

        let mitteInnen = Rechteck()
        mitteInnen.GrößeSetzen(breite: 17, höhe: 42)
        mitteInnen.PositionSetzen(x: x + 2, y: y + 9)
        mitteInnen.FarbeSetzen(farbe: "weiß")
        innenrechtecke.append(mitteInnen)

        let untenInnen  = Kreis()
        untenInnen.RadiusSetzen(radius: 8)
        untenInnen.PositionSetzen(x: x + 10, y: y + 50)
        untenInnen.FarbeSetzen(farbe: "weiß")
        innenkreise.append(untenInnen)
    }
}

/**
Darstellung einer Lampe

- author: Johannes Neumeyer
- version: 1.0
*/
class LampenSymbol
{
    private let kabel: Rechteck
    private let schirm: Dreieck
    private let birne: Kreis

	/**
	Baut das Symbol auf
	- parameters:
		- x: x-Koordinate
		- y: y-Koordinate
    */
    init(x: Int, y: Int)
    {
        kabel = Rechteck()
        kabel.PositionSetzen(x: x, y: y)
        kabel.GrößeSetzen(breite: 1, höhe: 30)
        kabel.FarbeSetzen(farbe: "schwarz")
        birne = Kreis()
        birne.RadiusSetzen(radius: 10)
        birne.PositionSetzen(x: x, y: y + 55)
        birne.FarbeSetzen(farbe: "weiß")
        schirm = Dreieck()
        schirm.GrößeSetzen(breite: 50, höhe: 25)
        schirm.PositionSetzen(x: x, y: y + 30)
        schirm.FarbeSetzen(farbe: "grau")
    }

    /**
	Meldet den neuen Zustand an das Symbol
	- parameters:
		- an: die Lampe ist eingeschaltet
    */
    func ÄnderungMelden(an: Bool)
    {
        if an
        {
            birne.FarbeSetzen(farbe: "gelb")
        }
        else
        {
            birne.FarbeSetzen(farbe: "weiß")
        }
    }
}

/**
Darstellung eines Rolladens

- author: Johannes Neumeyer
- version: 1.0
*/
class RollladenSymbol
{
    private let lamelle0: Rechteck
    private let lamelle1: Rechteck
    private let lamelle2: Rechteck
    private let lamelle3: Rechteck
    private let lamelle4: Rechteck
    private let lamelle5: Rechteck
    private let lamelle6: Rechteck
    private let lamelle7: Rechteck
    private let lamelle8: Rechteck

	/**
	Baut das Symbol auf
	- parameters:
		- x: x-Koordinate
		- y: y-Koordinate
    */
    init(x: Int, y: Int)
    {
        lamelle0 = Rechteck()
        lamelle0.FarbeSetzen(farbe: "schwarz")
        lamelle0.GrößeSetzen(breite: 100, höhe: 10)
        lamelle0.PositionSetzen(x: x, y: y)

        lamelle1 = Rechteck()
        lamelle1.FarbeSetzen(farbe: "schwarz")
        lamelle1.GrößeSetzen(breite: 100, höhe: 10)
        lamelle1.PositionSetzen(x: x, y: y + 11)

        lamelle2 = Rechteck()
        lamelle2.FarbeSetzen(farbe: "schwarz")
        lamelle2.GrößeSetzen(breite: 100, höhe: 10)
        lamelle2.PositionSetzen(x: x, y: y + 22)

        lamelle3 = Rechteck()
        lamelle3.FarbeSetzen(farbe: "schwarz")
        lamelle3.GrößeSetzen(breite: 100, höhe: 10)
        lamelle3.PositionSetzen(x: x, y: y + 33)

        lamelle4 = Rechteck()
        lamelle4.FarbeSetzen(farbe: "schwarz")
        lamelle4.GrößeSetzen(breite: 100, höhe: 10)
        lamelle4.PositionSetzen(x: x, y: y + 44)

        lamelle5 = Rechteck()
        lamelle5.FarbeSetzen(farbe: "schwarz")
        lamelle5.GrößeSetzen(breite: 100, höhe: 10)
        lamelle5.PositionSetzen(x: x, y: y + 55)

        lamelle6 = Rechteck()
        lamelle6.FarbeSetzen(farbe: "schwarz")
        lamelle6.GrößeSetzen(breite: 100, höhe: 10)
        lamelle6.PositionSetzen(x: x, y: y + 66)

        lamelle7 = Rechteck()
        lamelle7.FarbeSetzen(farbe: "schwarz")
        lamelle7.GrößeSetzen(breite: 100, höhe: 10)
        lamelle7.PositionSetzen(x: x, y: y + 77)

        lamelle8 = Rechteck()
        lamelle8.FarbeSetzen(farbe: "schwarz")
        lamelle8.GrößeSetzen(breite: 100, höhe: 10)
        lamelle8.PositionSetzen(x: x, y: y + 88)
    }

    /**
	Meldet den neuen Zustand an das Symbol
	- parameters:
		- oben: der Rolladen ist oben
    */
    func ÄnderungMelden(oben: Bool)
    {
        if oben
        {
            lamelle1.SichtbarkeitSetzen(sichtbar: false)
            lamelle2.SichtbarkeitSetzen(sichtbar: false)
            lamelle3.SichtbarkeitSetzen(sichtbar: false)
            lamelle4.SichtbarkeitSetzen(sichtbar: false)
            lamelle5.SichtbarkeitSetzen(sichtbar: false)
            lamelle6.SichtbarkeitSetzen(sichtbar: false)
            lamelle7.SichtbarkeitSetzen(sichtbar: false)
            lamelle8.SichtbarkeitSetzen(sichtbar: false)
        }
        else
        {
            lamelle1.SichtbarkeitSetzen(sichtbar: true)
            lamelle2.SichtbarkeitSetzen(sichtbar: true)
            lamelle3.SichtbarkeitSetzen(sichtbar: true)
            lamelle4.SichtbarkeitSetzen(sichtbar: true)
            lamelle5.SichtbarkeitSetzen(sichtbar: true)
            lamelle6.SichtbarkeitSetzen(sichtbar: true)
            lamelle7.SichtbarkeitSetzen(sichtbar: true)
            lamelle8.SichtbarkeitSetzen(sichtbar: true)
        }
    }
}

/**
Darstellung eines Kühlschranks

- author: Johannes Neumeyer
- version: 1.0
*/
class KühlschrankSymbol
{
    private let eckeLO: Kreis
    private let eckeRO: Kreis
    private let eckeLU: Kreis
    private let eckeRU: Kreis
    private let randLinks: Rechteck
    private let randOben: Rechteck
    private let randUnten: Rechteck
    private let randRechts: Rechteck

    private let eckeLOinnen: Kreis
    private let eckeROinnen: Kreis
    private let eckeLUinnen: Kreis
    private let eckeRUinnen: Kreis
    private let randLinksinnen: Rechteck
    private let randObeninnen: Rechteck
    private let randUnteninnen: Rechteck
    private let randRechtsinnen: Rechteck

    private let korpusInnen: Rechteck
    private let griffLinks: Kreis
    private let griffMitte: Rechteck
    private let griffRechts: Kreis

    private let ei1, ei2, ei3: Kreis
    private let eierfach: Rechteck

	/**
	Baut das Symbol auf
	- parameters:
		- x: x-Koordinate
		- y: y-Koordinate
    */
    init(x: Int, y: Int)
    {
        eckeLO = Kreis()
        eckeLO.RadiusSetzen(radius: 15)
        eckeLO.PositionSetzen(x: x + 15, y: y + 15)
        eckeLO.FarbeSetzen(farbe: "schwarz")
        randLinks = Rechteck()
        randLinks.GrößeSetzen(breite: 30, höhe: 100)
        randLinks.PositionSetzen(x: x, y: y + 15)
        randLinks.FarbeSetzen(farbe: "schwarz")
        eckeLU = Kreis()
        eckeLU.RadiusSetzen(radius: 15)
        eckeLU.PositionSetzen(x: x + 15, y: y + 115)
        eckeLU.FarbeSetzen(farbe: "schwarz")
        randUnten = Rechteck()
        randUnten.GrößeSetzen(breite: 60, höhe: 30)
        randUnten.PositionSetzen(x: x + 15, y: y + 100)
        randUnten.FarbeSetzen(farbe: "schwarz")
        randOben = Rechteck()
        randOben.GrößeSetzen(breite: 60, höhe: 30)
        randOben.PositionSetzen(x: x + 15, y: y)
        randOben.FarbeSetzen(farbe: "schwarz")
        eckeRO = Kreis()
        eckeRO.RadiusSetzen(radius: 15)
        eckeRO.PositionSetzen(x: x + 75, y: y + 15)
        eckeRO.FarbeSetzen(farbe: "schwarz")
        eckeRU = Kreis()
        eckeRU.RadiusSetzen(radius: 15)
        eckeRU.PositionSetzen(x: x + 75, y: y + 115)
        eckeRU.FarbeSetzen(farbe: "schwarz")
        randRechts = Rechteck()
        randRechts.GrößeSetzen(breite: 30, höhe: 100)
        randRechts.PositionSetzen(x: x + 60, y: y + 15)
        randRechts.FarbeSetzen(farbe: "schwarz")

        eckeLOinnen = Kreis()
        eckeLOinnen.RadiusSetzen(radius: 15)
        eckeLOinnen.PositionSetzen(x: x + 17, y: y + 17)
        eckeLOinnen.FarbeSetzen(farbe: "cyan")
        randLinksinnen = Rechteck()
        randLinksinnen.GrößeSetzen(breite: 30, höhe: 96)
        randLinksinnen.PositionSetzen(x: x + 2, y: y + 17)
        randLinksinnen.FarbeSetzen(farbe: "cyan")
        eckeLUinnen = Kreis()
        eckeLUinnen.RadiusSetzen(radius: 15)
        eckeLUinnen.PositionSetzen(x: x + 17, y: y + 113)
        eckeLUinnen.FarbeSetzen(farbe: "cyan")

        randUnteninnen = Rechteck()
        randUnteninnen.GrößeSetzen(breite: 56, höhe: 30)
        randUnteninnen.PositionSetzen(x: x + 17, y: y + 98)
        randUnteninnen.FarbeSetzen(farbe: "cyan")
        randObeninnen = Rechteck()
        randObeninnen.GrößeSetzen(breite: 56, höhe: 30)
        randObeninnen.PositionSetzen(x: x + 17, y: y + 2)
        randObeninnen.FarbeSetzen(farbe: "cyan")

        eckeROinnen = Kreis()
        eckeROinnen.RadiusSetzen(radius: 15)
        eckeROinnen.PositionSetzen(x: x + 73, y: y + 17)
        eckeROinnen.FarbeSetzen(farbe: "cyan")
        eckeRUinnen = Kreis()
        eckeRUinnen.RadiusSetzen(radius: 15)
        eckeRUinnen.PositionSetzen(x: x + 73, y: y + 113)
        eckeRUinnen.FarbeSetzen(farbe: "cyan")
        randRechtsinnen = Rechteck()
        randRechtsinnen.GrößeSetzen(breite: 30, höhe: 96)
        randRechtsinnen.PositionSetzen(x: x + 58, y: y + 17)
        randRechtsinnen.FarbeSetzen(farbe: "cyan")

        korpusInnen = Rechteck()
        korpusInnen.GrößeSetzen(breite: 60, höhe: 100)
        korpusInnen.PositionSetzen(x: x + 15, y: y + 15)
        korpusInnen.FarbeSetzen(farbe: "cyan")

        griffLinks = Kreis()
        griffLinks.RadiusSetzen(radius: 5)
        griffLinks.PositionSetzen(x: x + 15, y: y + 45)
        griffLinks.FarbeSetzen(farbe: "schwarz")

        griffMitte = Rechteck()
        griffMitte.GrößeSetzen(breite: 27, höhe: 10)
        griffMitte.PositionSetzen(x: x + 15, y: y + 40)
        griffMitte.FarbeSetzen(farbe: "schwarz")

        griffRechts = Kreis()
        griffRechts.RadiusSetzen(radius: 5)
        griffRechts.PositionSetzen(x: x + 41, y: y + 45)
        griffRechts.FarbeSetzen(farbe: "schwarz")

        ei1 = Kreis()
        ei1.RadiusSetzen(radius: 10)
        ei1.PositionSetzen(x: x + 21, y: y + 80)
        ei1.FarbeSetzen(farbe: "orange")

        ei2 = Kreis()
        ei2.RadiusSetzen(radius: 10)
        ei2.PositionSetzen(x: x + 44, y: y + 80)
        ei2.FarbeSetzen(farbe: "orange")

        ei3 = Kreis()
        ei3.RadiusSetzen(radius: 10)
        ei3.PositionSetzen(x: x + 67, y: y + 80)
        ei3.FarbeSetzen(farbe: "orange")

        eierfach = Rechteck()
        eierfach.GrößeSetzen(breite: 70, höhe: 12)
        eierfach.PositionSetzen(x: x + 10, y: y + 85)
        eierfach.FarbeSetzen(farbe: "grau")

    }
    
    /**
	Meldet den neuen Zustand an das Symbol
	- parameters:
		- leer: das Eierfach ist leer
    */
    func ÄnderungMelden(leer: Bool)
    {
        if (leer)
        {
            ei1.FarbeSetzen(farbe: "rot")
            ei2.FarbeSetzen(farbe: "rot")
            ei3.FarbeSetzen(farbe: "rot")
        }
        else
        {
            ei1.FarbeSetzen(farbe: "weiß")
            ei2.FarbeSetzen(farbe: "weiß")
            ei3.FarbeSetzen(farbe: "weiß")
        }
    }
}
//#-editable-code
/**
Beschreibt einen Bewegungsmelder

- author: Albert Wiedemann
- version 1.0
 */
class Bewegungsmelder
{
    /** Name des Sensors */
    private let name: String
    /** aktueller Wert der Messung */
    private var an: Bool
    /** Lampe, der Änderungen gemeldet werden */
    private var beobachter: Lampe!
    
    /**
	Legt den Namen und den Beobachter fest.
	- parameters:
		- namensZusatz: individualler Namensteil des Sensors
    */
    init(namensZusatz: String)
    {
        name = "Bewegungsmelder \(namensZusatz)"
        beobachter = nil
        an = false
    }
    
    /**
    Meldet den Namen des Geräts zurück
    - returns: Name
    */
    func NameGeben() -> String
    {
        return name
    }
    
    /**
	Registriert einen Beobachter
	- parameters:
		- beobachter: wird von jeder Wertänderung benachrichtigt
    */
    func BeobachterRegistrieren (beobachter: Lampe)
    {
        self.beobachter = beobachter
    }
    
    /**
	Setzt den neuen Sensorwert
	- parameters:
		- an: der neue Sensorwert
    */
    func WertSetzen (an: Bool)
    {
        self.an = an
        beobachter.WertänderungMeldenBewegungsmelder(wert: an)
    }
    
    /**
    Meldet den Zustand des Sensors
    - returns: Zustand als Zeichenkette
    */
    func ZustandGeben() -> String
    {
        return an ? "Bewegung" : "Ruhe"
    }
}

/**
Beschreibt einen Lichtsensor

- author: Albert Wiedemann
- version 1.0
*/
class Sonnensensor
{
    /** Name des Sensors */
    private let name: String
    /** aktueller Wert der Messung */
    private var aktuellerWert: Int
    /** Lampe, der Änderungen gemeldet werden */
    private var beobachter: Lampe!
    
    /**
	Legt den Namen und den Beobachter fest.
	- parameters:
		- namensZusatz: individualler Namensteil des Sensors
    */
    init(namensZusatz: String)
    {
        name = "Bewegungsmelder \(namensZusatz)"
        beobachter = nil
        aktuellerWert = 0
    }
    
    /**
    Meldet den Namen des Geräts zurück
    - returns: Name
    */
    func NameGeben() -> String
    {
        return name
    }
    
    /**
	Registriert einen Beobachter
	- parameters:
		- beobachter: wird von jeder Wertänderung benachrichtigt
    */
    func BeobachterRegistrieren (beobachter: Lampe)
    {
        self.beobachter = beobachter
    }
    
    /**
	Setzt den neuen Sensorwert
	- parameters:
		- eingabe: der neue Sensorwert
    */
    func WertSetzen (eingabe: Int)
    {
        if (eingabe >= 0) && (eingabe <= 100)
        {
            aktuellerWert = eingabe
            beobachter.WertänderungMeldenSonnenSensor(wert: aktuellerWert)
        }
    }
    
    /**
    Meldet den Zustand des Sensors
    - returns: Zustand als Zeichenkette
    */
    func ZustandGeben() -> String
    {
        return "\(aktuellerWert) %"
    }
}

/**
Beschreibt eine Lampe

- author: Albert Wiedemann
- version 1.0
*/
class Lampe
{
    /** Name der Hauskomponente */
    private let name: String
    /** Zustand der Lampe */
    private var an: Bool
    /** Automatikbetrieb */
    private var automatik: Bool
    /** Wert des Bewegungsmelders */
    private var bewegung: Bool
    /** Wert des Sonnensensors */
    private var helligkeit: Int
    /** Darstellungssymbol */
    private let symbol: LampenSymbol

    /**
	Legt den Namen und das Darstellungssymbol fest
	- parameters:
		- namensZusatz: individualler Namensteil der Komponente
		- sy: Darstellungssymbol
		- b: Bewegungsmelder
		- s: Sonnensensor
    */
    init(namensZusatz: String, sy: LampenSymbol, b: Bewegungsmelder, s: Sonnensensor)
    {
        name = "Lampe \(namensZusatz)"
        bewegung = false
        helligkeit = 0
        an = false
        automatik = true
        symbol = sy
        symbol.ÄnderungMelden(an: an)
        s.BeobachterRegistrieren(beobachter: self)
        b.BeobachterRegistrieren(beobachter: self)
    }
    
    /**
    Meldet den Namen des Geräts zurück
    - returns: Name
    */
    func NameGeben() -> String
    {
        return name
    }

    /**
	Wird von Sonnensensor bei einem neuen Helligkeitswert aufgerufen
	- parameters:
		- wert: der neue Helligkeitswert
    */
    func WertänderungMeldenSonnenSensor(wert: Int)
    {
        helligkeit = wert
        if automatik
        {
            an = bewegung && (helligkeit < 30)
            symbol.ÄnderungMelden(an: an)
        }
    }

    /**
    Wird von Bewegungsmelder bei einem neuen Bewegungszustand aufgerufen
	- parameters:
		- wert: der neue Bewegungswert
    */
    func WertänderungMeldenBewegungsmelder(wert: Bool)
    {
        bewegung = wert
        if automatik
        {
            an = bewegung && (helligkeit < 30)
            symbol.ÄnderungMelden(an: an)
        }
    }
    
    /**
    Meldet den Zustand der Komponente
    - returns: Zustand als Zeichenkette
    */
    func ZustandGeben() -> String
    {
        return an ? "ein" : "aus"
    }
    
    /**
    Schaltet die Komponente dauerhaft ein
    */
    func Einschalten()
    {
        an = true
        automatik = false
        symbol.ÄnderungMelden(an: an)
    }
    
    /**
    Schaltet die Komponente dauerhaft aus
    */
    func Ausschalten()
    {
        an = false
        automatik = false
        symbol.ÄnderungMelden(an: an)
    }
    
    /**
    Schaltet die Komponente auf Automatikbetrieb
    */
    func AutomatikAktivieren()
    {
        an = bewegung && (helligkeit < 30)
        automatik = true
        symbol.ÄnderungMelden(an: an)
    }
}

/**
Beschreibt ein Thermometer

- author: Albert Wiedemann
- version 1.0
*/
class Thermometer
{
    /** Name des Sensors */
    private let name: String
    /** aktueller Wert der Messung */
    private var aktuellerWert: Int
    /** Heizkörper, dem Änderungen gemeldet werden */
    private var beobachter: Heizkörper!

    /**
	Legt den Namen und den Beobachter fest.
	- parameters:
		- namensZusatz: individualler Namensteil des Sensors
    */
    init(namensZusatz: String)
    {
        name = "Thermometer \(namensZusatz)"
        beobachter = nil
        aktuellerWert = 0
    }
    
    /**
    Meldet den Namen des Geräts zurück
    - returns: Name
    */
    func NameGeben() -> String
    {
        return name
    }
     
    /**
	Registriert einen Beobachter
	- parameters:
		- beobachter: wird von jeder Wertänderung benachrichtigt
    */
    func BeobachterRegistrieren (beobachter: Heizkörper)
    {
        self.beobachter = beobachter
    }
   
    /**
	Setzt den neuen Sensorwert
	- parameters:
		- eingabe: der neue Sensorwert
    */
    func WertSetzen (eingabe: Int)
    {
        if (eingabe >= -50) && (eingabe <= 100)
        {
            aktuellerWert = eingabe
            beobachter.WertänderungMelden(wert: aktuellerWert)
        }
    }
    
    /**
    Meldet den Zustand der Komponente
    - returns: Zustand als Zeichenkette
    */
    func ZustandGeben() -> String
    {
        return "\(aktuellerWert) ˚C"
    }
}

/**
Beschreibt einen Heizkörper

- author: Albert Wiedemann
- version 1.0
*/
class Heizkörper
{
    /** Name der Hauskomponente */
    private let name: String
    /** Zustand der Lampe */
    private var an: Bool
    /** Automatikbetrieb */
    private var automatik: Bool
    /** Wert des Thermometers */
    private var temperatur: Int
    /** Darstellungssymbol */
    private let symbol: HeizkörperSymbol

    /**
	Legt den Namen und das Darstellungssymbol fest
	- parameters:
		- namensZusatz: individualler Namensteil der Komponente
		- sy: Darstellungssymbol
		- t: Thermometer
    */
    init(namensZusatz: String, sy: HeizkörperSymbol, t: Thermometer)
    {
        name = "Heizkörper \(namensZusatz)"
        temperatur = 0
        an = true
        automatik = true
        symbol = sy
        symbol.ÄnderungMelden(an: an)
        t.BeobachterRegistrieren(beobachter: self)
    }
    
    /**
    Meldet den Namen des Geräts zurück
    - returns: Name
    */
    func NameGeben() -> String
    {
        return name
    }

    /**
	Wird von Sonnensensor bei einem neuen Helligkeitswert aufgerufen
	- parameters:
		- wert: der neue Temperaturwert
    */
    func WertänderungMelden(wert: Int)
    {
        temperatur = wert
        if automatik
        {
            an = temperatur < 22
            symbol.ÄnderungMelden(an: an)
        }
    }
    
    /**
    Meldet den Zustand der Komponente
    - returns: Zustand als Zeichenkette
    */
    func ZustandGeben() -> String
    {
        return an ? "ein" : "aus"
    }
    
    /**
    Schaltet die Komponente dauerhaft ein
    */
    func Einschalten()
    {
        an = true
        automatik = false
        symbol.ÄnderungMelden(an: an)
    }
    
    /**
    Schaltet die Komponente dauerhaft aus
    */
    func Ausschalten()
    {
        an = false
        automatik = false
        symbol.ÄnderungMelden(an: an)
    }
    
    /**
    Schaltet die Komponente auf Automatikbetrieb
    */
    func AutomatikAktivieren()
    {
        an = temperatur < 22
        automatik = true
        symbol.ÄnderungMelden(an: an)
    }
}

/**
Beschreibt eine Waage

- author: Albert Wiedemann
- version 1.0
*/
class Waage
{
    /** Name des Sensors */
    private let name: String
    /** aktueller Wert der Messung */
    private var aktuellerWert: Int
    /** Kühlschrank, dem Änderungen gemeldet werden */
    private var beobachter: Kühlschrank!
    
    /**
	Legt den Namen und den Beobachter fest.
	- parameters:
		- namensZusatz: individualler Namensteil des Sensors
    */
    init(namensZusatz: String)
    {
        name = "Waage\(namensZusatz)"
        beobachter = nil
        aktuellerWert = 0
    }
    
    /**
    Meldet den Namen des Geräts zurück
    - returns: Name
    */
    func NameGeben() -> String
    {
        return name
    }
    
    /**
	Registriert einen Beobachter
	- parameters:
		- beobachter: wird von jeder Wertänderung benachrichtigt
    */
    func BeobachterRegistrieren (beobachter: Kühlschrank)
    {
        self.beobachter = beobachter
    }

    /**
	- parameters:
		- eingabe: der neue Sensorwert
    */
    func WertSetzen (eingabe: Int)
    {
        if (eingabe >= 0) && (eingabe < 10000)
        {
            aktuellerWert = eingabe
            beobachter.WertänderungMelden(wert: eingabe)
        }
    }
    
    /**
    Meldet den Zustand der Komponente
    - returns: Zustand als Zeichenkette
    */
    func ZustandGeben() -> String
    {
        return "\(aktuellerWert) g"
    }
}

/**
Beschreibt einen Kühlschrank

- author: Albert Wiedemann
- version 1.0
*/
class Kühlschrank
{
    /** Name der Hauskomponente */
    private let name: String
    /** Zustand des Eierfachs */
    private var leer: Bool
    /** Wert der Waage */
    private var gewicht: Int
    /** Darstellungssymbol */
    private let symbol: KühlschrankSymbol

    /**
     * Legt den Namen und das Darstellungssymbol fest
     * @param namensZusatz individualler Namensteil der Komponente
     * @param sy Darstellungssymbol
     * @param w Waage
     */
    /**
	Legt den Namen und das Darstellungssymbol fest
	- parameters:
		- namensZusatz: individualler Namensteil der Komponente
		- sy: Darstellungssymbol
		- w: Waage
    */
    init(namensZusatz: String, sy: KühlschrankSymbol, w: Waage)
    {
        name = "Kühlschrank \(namensZusatz)"
        gewicht = 0
        leer = true
        symbol = sy
        symbol.ÄnderungMelden(leer: leer)
        w.BeobachterRegistrieren(beobachter: self)
    }
    
    /**
    Meldet den Namen des Geräts zurück
    - returns: Name
    */
    func NameGeben() -> String
    {
        return name
    }

    /**
	Wird von der Waage bei einem neuen Gewicht aufgerufen
	- parameters:
		- wert: das neue Gewicht
    */
    func WertänderungMelden(wert: Int)
    {
        gewicht = wert
        leer = gewicht < 100
        symbol.ÄnderungMelden(leer: leer)
    }
    
    /**
    Meldet den Zustand der Komponente
    - returns: Zustand als Zeichenkette
    */
    func ZustandGeben() -> String
    {
        return leer ? "Eierfach leer" : "Eierfach voll"
    }
    
    /**
     * Tut nichts
     */
    func Einschalten()
    {
    }
    
    /**
     * Tut nichts
     */
    func Ausschalten()
    {
    }
    
    /**
     * Tut nichts
     */
    func AutomatikAktivieren()
    {
    }
}

/**
Beschreibt eine Uhr

- author: Albert Wiedemann
- version 1.0
*/
class Uhr
{
    /** Name des Sensors */
    private let name: String
    /** aktueller Wert der Zeit, Stunden */
    private var stunden: Int
    /** aktueller Wert der Zeit, minuten */
    private var minuten: Int
    /** aktueller Wert der Zeit, Sekunden */
    private var sekunden: Int
    /** Rollladen, dem Änderungen gemeldet werden */
    private var beobachter: Rollladen!
    
    /**
	Legt den Namen und den Beobachter fest.
	- parameters:
		- namensZusatz: individualler Namensteil des Sensors
    */
    init(namensZusatz: String)
    {
        name = "Uhr\(namensZusatz)"
        beobachter = nil
        stunden = 0
        minuten = 0
        sekunden = 0
    }
    
    /**
    Meldet den Namen des Geräts zurück
    - returns: Name
    */
    func NameGeben() -> String
    {
        return name
    }
    
    /**
	Registriert einen Beobachter
	- parameters:
		- beobachter: wird von jeder Wertänderung benachrichtigt
    */
    func BeobachterRegistrieren (beobachter: Rollladen)
    {
        self.beobachter = beobachter
    }

    /**
	- parameters:
		- stunden: der neue Sensorwert
    */
    func WertSetzen (stunden: Int)
    {
        if (stunden >= 0) && (stunden < 24)
        {
            self.stunden = stunden
            beobachter.WertänderungMeldenUhr(wert: stunden*10000 + minuten*100 + sekunden)
        }
    }
    
    /**
    Meldet den Zustand der Komponente
    - returns: Zustand als Zeichenkette
    */
    func ZustandGeben() -> String
    {
        return "\(stunden):" + (minuten < 10 ? "0\(minuten)" : "\(minuten)") + ":" + (sekunden < 10 ? "0\(sekunden)" : "\(sekunden)") + "Uhr"
    }
}

/**
Beschreibt einen Windsensor

- author: Albert Wiedemann
- version 1.0
*/
class Windsensor
{
    /** Name des Sensors */
    private let name: String
    /** aktueller Wert der Messung */
    private var aktuellerWert: Int
    /** Rolladen, dem Änderungen gemeldet werden */
    private var beobachter: Rollladen!
    
    /**
	Legt den Namen und den Beobachter fest.
	- parameters:
		- namensZusatz: individualler Namensteil des Sensors
    */
    init(namensZusatz: String)
    {
        name = "Windsensor \(namensZusatz)"
        beobachter = nil
        aktuellerWert = 0
    }
    
    /**
    Meldet den Namen des Geräts zurück
    - returns: Name
    */
    func NameGeben() -> String
    {
        return name
    }
    
    /**
	Registriert einen Beobachter
	- parameters:
		- beobachter: wird von jeder Wertänderung benachrichtigt
    */
    func BeobachterRegistrieren (beobachter: Rollladen)
    {
        self.beobachter = beobachter
    }

    /**
	- parameters:
		- eingabe: der neue Sensorwert
    */
    func WertSetzen (eingabe: Int)
    {
        if (eingabe >= 0) && (eingabe <= 12)
        {
            aktuellerWert = eingabe
            beobachter.WertänderungMeldenWindSensor(wert: aktuellerWert)
        }
    }
    
    /**
    Meldet den Zustand der Komponente
    - returns: Zustand als Zeichenkette
    */
    func ZustandGeben() -> String
    {
        return "\(aktuellerWert) Bft"
    }
}

/**
Beschreibt einen Rolladen

- author: Albert Wiedemann
- version 1.0
*/
class Rollladen
{
    /** Name der Hauskomponente */
    private let name: String
    /** Zustand des Rollladens */
    private var oben: Bool
    /** Automatikbetrieb */
    private var automatik: Bool
    /** Wert des Windsensors */
    private var windwert: Int
    /** Wert der Uhr */
    private var uhrzeit: Int
    /** Darstellungssymbol */
    private let symbol: RollladenSymbol

    /**
	Legt den Namen und das Darstellungssymbol fest
	- parameters:
		- namensZusatz: individualler Namensteil der Komponente
		- sy: Darstellungssymbol
		- w: Windsensor
		- u: Uhr
    */
    init(namensZusatz: String, sy: RollladenSymbol, w: Windsensor, u: Uhr)
    {
        name = "Rollladen \(namensZusatz)"
        oben = false
        automatik = true
        windwert = 0
        uhrzeit = 0
        symbol = sy
        symbol.ÄnderungMelden(oben: oben)
        w.BeobachterRegistrieren(beobachter: self)
        u.BeobachterRegistrieren(beobachter: self)
    }
    
    /**
    Meldet den Namen des Geräts zurück
    - returns: Name
    */
    func NameGeben() -> String
    {
        return name
    }

    /**
	Wird vom Windsensor bei einer neuen Windstärke aufgerufen
	- parameters:
		- wert: die neue Windstärke
    */
    func WertänderungMeldenWindSensor(wert: Int)
    {
        windwert = wert
        if automatik
        {
            oben = (windwert > 6) || (uhrzeit > 60000) && (uhrzeit < 200000)
            symbol.ÄnderungMelden(oben: oben)
        }
    }

    /**
	Wird vom Windsensor bei einer neuen Windstärke aufgerufen
	- parameters:
		- wert: die neue Windstärke
    */
    func WertänderungMeldenUhr(wert: Int)
    {
        uhrzeit = wert
        if automatik
        {
            oben = (windwert > 6) || (uhrzeit > 60000) && (uhrzeit < 200000)
            symbol.ÄnderungMelden(oben: oben)
        }
    }
        
    /**
    Meldet den Zustand der Komponente
    - returns: Zustand als Zeichenkette
    */
    func ZustandGeben() -> String
    {
        return oben ? "offen" : "geschlossen"
    }

    /**
    Zieht den Rollladen dauerhaft hoch
    */
    func Hochziehen()
    {
        oben = true
        automatik = false
        symbol.ÄnderungMelden(oben: oben)
    }
    
    /**
    lässt den Rollladen dauerhaft runter
    */
    func Runterlassen()
    {
        oben = false
        automatik = false
        symbol.ÄnderungMelden(oben: oben)
    }
    
    /**
    Schaltet die Komponente auf Automatikbetrieb
    */
    func AutomatikAktivieren()
    {
        oben = (windwert > 6) || (uhrzeit > 60000) && (uhrzeit < 200000)
        automatik = true
        symbol.ÄnderungMelden(oben: oben)
    }
}


/**
Verwaltung des Hauses

- author: Albert Wiedemann
- version: 1.0
*/
class Haus
{
    private let hintergrund: HintergrundSymbol
    private let thermometerEsszimmer: Thermometer
    private let heizkörperSymbolEsszimmer: HeizkörperSymbol
    private let heizkörperEsszimmer: Heizkörper
    private let uhrWohnzimmer1: Uhr
    private let windsensorWohnzimmer1: Windsensor
    private let rollladenSymbolWohnzimmer1: RollladenSymbol
    private let rollladenWohnzimmer1: Rollladen
    private let uhrWohnzimmer2: Uhr
    private let windsensorWohnzimmer2: Windsensor
    private let rollladenSymbolWohnzimmer2: RollladenSymbol
    private let rollladenWohnzimmer2: Rollladen
    private let uhrEsszimmer: Uhr
    private let windsensorEsszimmer: Windsensor
    private let rollladenSymbolEsszimmer: RollladenSymbol
    private let rollladenEsszimmer: Rollladen
    private let uhrKüche: Uhr
    private let windsensorKüche: Windsensor
    private let rollladenSymbolKüche: RollladenSymbol
    private let rollladenKüche: Rollladen
    private let bewegungsmelderWohnzimmer2_1: Bewegungsmelder
    private let sonnensensorWohnzimmer2_1: Sonnensensor
    private let lampenSymbolWohnzimmer2_1: LampenSymbol
    private let lampeWohnzimmer2_1: Lampe
    private let bewegungsmelderWohnzimmer2_2: Bewegungsmelder
    private let sonnensensorWohnzimmer2_2: Sonnensensor
    private let lampenSymbolWohnzimmer2_2: LampenSymbol
    private let lampeWohnzimmer2_2: Lampe
    private let waageKüche: Waage
    private let kühlschrankSymbolKüche: KühlschrankSymbol
    private let kühlschrankKüche: Kühlschrank

    /**
    legt die Sensoren und Komponenten des Hauses an
    */
    init()
    {
        hintergrund = HintergrundSymbol()
        thermometerEsszimmer = Thermometer(namensZusatz: "Esszimmer")
        heizkörperSymbolEsszimmer = HeizkörperSymbol(x: 420, y: 440)
        heizkörperEsszimmer = Heizkörper(namensZusatz: "Esszimmer", sy: heizkörperSymbolEsszimmer, t: thermometerEsszimmer)
        uhrWohnzimmer1 = Uhr(namensZusatz: "Wohnzimmer 1")
        windsensorWohnzimmer1 = Windsensor(namensZusatz: "Wohnzimmer1")
        rollladenSymbolWohnzimmer1 = RollladenSymbol(x: 250, y: 125)
        rollladenWohnzimmer1 = Rollladen(namensZusatz: "Wohnzimmer1", sy: rollladenSymbolWohnzimmer1, w: windsensorWohnzimmer1, u: uhrWohnzimmer1)
        uhrWohnzimmer2 = Uhr(namensZusatz: "Wohnzimmer 2")
        windsensorWohnzimmer2 = Windsensor(namensZusatz: "Wohnzimmer2")
        rollladenSymbolWohnzimmer2 = RollladenSymbol(x: 500, y: 125)
        rollladenWohnzimmer2 = Rollladen(namensZusatz: "Wohnzimmer2", sy: rollladenSymbolWohnzimmer2, w: windsensorWohnzimmer2, u: uhrWohnzimmer2)
        uhrEsszimmer = Uhr(namensZusatz: "Esszimmer")
        windsensorEsszimmer = Windsensor(namensZusatz: "Esszimmer")
        rollladenSymbolEsszimmer = RollladenSymbol(x: 500, y: 325)
        rollladenEsszimmer = Rollladen(namensZusatz: "Esszimmer", sy: rollladenSymbolEsszimmer, w: windsensorEsszimmer, u: uhrEsszimmer)
        uhrKüche = Uhr(namensZusatz: "Küche")
        windsensorKüche = Windsensor(namensZusatz: "Küche")
        rollladenSymbolKüche = RollladenSymbol(x: 250, y: 325)
        rollladenKüche = Rollladen(namensZusatz: "Küche", sy: rollladenSymbolKüche, w: windsensorKüche, u: uhrKüche)
        sonnensensorWohnzimmer2_1 = Sonnensensor(namensZusatz: "Wohnzimmer2 1")
        bewegungsmelderWohnzimmer2_1 = Bewegungsmelder(namensZusatz: "Wohnzimmer2 1")
        lampenSymbolWohnzimmer2_1 = LampenSymbol(x: 450, y: 105)
        lampeWohnzimmer2_1 = Lampe(namensZusatz: "Wohnzimmer2_1", sy: lampenSymbolWohnzimmer2_1, b: bewegungsmelderWohnzimmer2_1, s: sonnensensorWohnzimmer2_1)
        sonnensensorWohnzimmer2_2 = Sonnensensor(namensZusatz: "Wohnzimmer2 2")
        bewegungsmelderWohnzimmer2_2 = Bewegungsmelder(namensZusatz: "Wohnzimmer2 2")
        lampenSymbolWohnzimmer2_2 = LampenSymbol(x: 550, y: 105)
        lampeWohnzimmer2_2 = Lampe(namensZusatz: "Wohnzimmer2 2", sy: lampenSymbolWohnzimmer2_2, b: bewegungsmelderWohnzimmer2_2, s: sonnensensorWohnzimmer2_2)
        waageKüche = Waage(namensZusatz: "Küche")
        kühlschrankSymbolKüche = KühlschrankSymbol(x: 158, y: 370)
        kühlschrankKüche = Kühlschrank(namensZusatz: "Küche", sy: kühlschrankSymbolKüche, w: waageKüche)
    }
    
    /**
	Setzt das Thermometer im Esszimmer auf einen neuen Wert
	- parameters:
		- eingabe: neuer Temperaturwert
    */
    func ThermometerEsszimmerWertSetzen (eingabe: Int)
    {
        thermometerEsszimmer.WertSetzen(eingabe: eingabe)
    }
    
    /**
	Setzt Uhr in Wohnzimmer 1 auf eine neue Zeit
	- parameters:
		- stunden: neue Stundenangabe
    */
    func UhrWohnzimmer1WertSetzen (stunden: Int)
    {
        uhrWohnzimmer1.WertSetzen(stunden: stunden);
    }
    
    /**
	Setzt Windsensor in Wohnzimmer 1 auf einen neuen Wert
	- parameters:
		- eingabe: neue Windstärke
    */
    func WindsensorWohnzimmer1WertSetzen (eingabe: Int)
    {
        windsensorWohnzimmer1.WertSetzen(eingabe: eingabe);
    }
    
    /**
	Setzt Bewegunsmelder in Wohnzimmer 2 auf einen neuen Wert
	- parameters:
		- an: neuer Wert
    */
    func BewegungsmelderWohnzimmer2WertSetzen (an: Bool)
    {
        bewegungsmelderWohnzimmer2_1.WertSetzen(an: an);
    }
    
    /**
	Setzt Sonnensensor in Wohnzimmer 2 auf einen neuen Wert
	- parameters:
		- eingabe: eingabe neue Helligkeit
    */
    func SonnensensorWohnzimmer2WertSetzen (eingabe: Int)
    {
        sonnensensorWohnzimmer2_1.WertSetzen(eingabe: eingabe);
    }
    
    /**
	Setzt Waage in der Küche auf einen neuen Wert
	- parameters:
		- eingabe: neues Gewicht
    */
    func WaageKücheWertSetzen (eingabe: Int)
    {
        waageKüche.WertSetzen(eingabe: eingabe);
    }
    
    /**
    Schaltet den Heizkörper im Esszimmer dauerhaft ein
    */
    func HeizkörperEsszimmerEinschalten()
    {
        heizkörperEsszimmer.Einschalten()
    }
    
    /**
    Schaltet den Heizkörper im Esszimmer dauerhaft aus
    */
    func HeizkörperEsszimmerAusschalten()
    {
        heizkörperEsszimmer.Ausschalten()
    }
    
    /**
    Setzt den Heizkörper im Esszimmer auf Automatikbetrieb
    */
    func HeizkörperEsszimmerAutomatikSetzen()
    {
        heizkörperEsszimmer.AutomatikAktivieren()
    }
    
    /**
    Schaltet die Lampe 1 in Wohnzimmer 2 dauerhaft ein
    */
    func LampeWohnzimmer2_1Einschalten()
    {
        lampeWohnzimmer2_1.Einschalten()
    }
    
    /**
    Schaltet die Lampe 1 in Wohnzimmer 2 dauerhaft aus
    */
    func LampeWohnzimmer2_1Ausschalten()
    {
        lampeWohnzimmer2_1.Ausschalten()
    }
    
    /**
    Setzt die Lampe 1 in Wohnzimmer 2 auf Automatikbetrieb
    */
    func LampeWohnzimmer2_1AutomatikSetzen()
    {
        lampeWohnzimmer2_1.AutomatikAktivieren()
    }
    
    /**
    Schaltet die Lampe 2 in Wohnzimmer 2 dauerhaft ein
    */
    func LampeWohnzimmer2_2Einschalten()
    {
        lampeWohnzimmer2_2.Einschalten()
    }
    
    /**
    Schaltet die Lampe 2 in Wohnzimmer 2 dauerhaft aus
    */
    func LampeWohnzimmer2_2Ausschalten()
    {
        lampeWohnzimmer2_2.Ausschalten()
    }
    
    /**
    Setzt die Lampe 2 in Wohnzimmer 2 auf Automatikbetrieb
    */
    func LampeWohnzimmer2_2AutomatikSetzen()
    {
        lampeWohnzimmer2_2.AutomatikAktivieren()
    }
    
    /**
    Zieht Rollladen in Wohnzimmer 1 dauerhaft hoch
    */
    func RollladenWohnzimmer1Hochziehen()
    {
        rollladenWohnzimmer1.Hochziehen()
    }
    
    /**
    Lässt Rollladen in Wohnzimmer 1 dauerhaft runter
    */
    func RollladenWohnzimmer1Runterlassen()
    {
        rollladenWohnzimmer1.Runterlassen()
    }
    
    /**
    Setzt Rollladen in Wohnzimmer 1 auf Automatikbetrieb
    */
    func RollladenWohnzimmer1AutomatikSetzen()
    {
        rollladenWohnzimmer1.AutomatikAktivieren()
    }
    
    /**
    Zieht Rollladen in Wohnzimmer 2 dauerhaft hoch
    */
    func RollladenWohnzimmer2Hochziehen()
    {
        rollladenWohnzimmer2.Hochziehen()
    }
    
    /**
    Lässt Rollladen in Wohnzimmer 2 dauerhaft runter
    */
    func RollladenWohnzimmer2Runterlassen()
    {
        rollladenWohnzimmer2.Runterlassen()
    }
    
    /**
    Setzt Rollladen in Wohnzimmer 2 auf Automatikbetrieb
    */
    func RollladenWohnzimmer2AutomatikSetzen()
    {
        rollladenWohnzimmer2.AutomatikAktivieren()
    }
    
    /**
    Zieht Rollladen im Esszimmer dauerhaft hoch
    */
    func RollladenEsszimmerHochziehen()
    {
        rollladenEsszimmer.Hochziehen()
    }
    
    /**
    Lässt Rollladen im Esszimmer dauerhaft runter
    */
    func RollladenEsszimmerRunterlassen()
    {
        rollladenEsszimmer.Runterlassen()
    }
    
    /**
    Setzt Rollladen im Esszimmer auf Automatikbetrieb
    */
    func RollladenEsszimmerAutomatikSetzen()
    {
        rollladenEsszimmer.AutomatikAktivieren()
    }
    
    /**
    Zieht Rollladen in der Küche dauerhaft hoch
    */
    func RollladenKücheHochziehen()
    {
        rollladenKüche.Hochziehen()
    }
    
    /**
    Lässt Rollladen in der Küche dauerhaft runter
    */
    func RollladenKücheRunterlassen()
    {
        rollladenKüche.Runterlassen()
    }
    
    /**
    Setzt Rollladen in der Küche auf Automatikbetrieb
    */
    func RollladenKücheAutomatikSetzen()
    {
        rollladenKüche.AutomatikAktivieren()
    }
    
    /**
    Zeigt die zustände aller Geräte an
    */
    func ZuständeAnzeigen()
    {
    	print(thermometerEsszimmer.NameGeben() + ": " + thermometerEsszimmer.ZustandGeben())
        print(heizkörperEsszimmer.NameGeben() + ": " + heizkörperEsszimmer.ZustandGeben())
        print(uhrWohnzimmer1.NameGeben() + ": " + uhrWohnzimmer1.ZustandGeben());
        print(windsensorWohnzimmer1.NameGeben() + ": " + windsensorWohnzimmer1.ZustandGeben())
        print(rollladenWohnzimmer1.NameGeben() + ": " + rollladenWohnzimmer1.ZustandGeben())
        print(rollladenWohnzimmer2.NameGeben() + ": " + rollladenWohnzimmer2.ZustandGeben())
        print(rollladenEsszimmer.NameGeben() + ": " + rollladenEsszimmer.ZustandGeben())
        print(rollladenKüche.NameGeben() + ": " + rollladenKüche.ZustandGeben())
        print(sonnensensorWohnzimmer2_1.NameGeben() + ": " + sonnensensorWohnzimmer2_1.ZustandGeben())
        print(bewegungsmelderWohnzimmer2_1.NameGeben() + ": " + bewegungsmelderWohnzimmer2_1.ZustandGeben())
        print(lampeWohnzimmer2_1.NameGeben() + ": " + lampeWohnzimmer2_1.ZustandGeben())
        print(lampeWohnzimmer2_2.NameGeben() + ": " + lampeWohnzimmer2_2.ZustandGeben())
        print(waageKüche.NameGeben() + ": " + waageKüche.ZustandGeben());
        print(kühlschrankKüche.NameGeben() + ": " + kühlschrankKüche.ZustandGeben())
    }
}

//#-end-editable-code
/*:
a\
Alle Rollläden des Hauses sollen zusammen geöffnet, geschlossen bzw. auf Automatikbetrieb gestellt werden können. Erstelle dazu ein geeignetes Feld und die passenden Methoden.\
b\
Alle Lampen des Wohnzimmers 2 sollen zusammen eingeschaltet, ausgeschaltet bzw. auf Automatikbetrieb gestellt werden können. Erstelle auch dazu ein geeignetes Feld und die passenden Methoden.\
c\
Die Lampen im Wohnzimmer 2 schalten sich leicht unterschiedlich ein und aus, weil jede durch einen eigenen Sonnensensor und einen eigenen Bewegungsmelder gesteuert wird. Besser wäre es, wenn nur ein Sonnensensor und ein Bewegungsmelder nötig wären, die ihre Information an alle Lampen weitergeben. Ersetze dazu in jedem Sensor das Attribut zum Speichern der Referenz auf eine Lampe durch ein entsprechendes Feld. Ergänze dann eine Methode *BeobachterRegistrieren(l: LAMPE)*, mit der sich eine Lampe registrieren kann, um über Änderungen informiert zu werden. Passe auch die Klasse LAMPE so an, dass sie sich im Konstruktor bei ihren Sensoren registriert.\
d\
Für Schnelle: Ändere auch die Steuerung der Rollläden so ab, dass alle von einem Windsensor und einer Uhr gesteuert werden.
*/
//#-editable-code

let h = Haus()
h.ThermometerEsszimmerWertSetzen(eingabe: 25)
h.WaageKücheWertSetzen(eingabe: 100)
h.BewegungsmelderWohnzimmer2WertSetzen(an: true)
h.ZuständeAnzeigen()

//#-end-editable-code
